\chapter{Proof system}\label{ch:mcsat}

\silentindex{mcsat}
The \emph{lazy SMT solving} approach presented so far is guided by the idea to have a clear separation between the Boolean reasoning and the theory reasoning. It is possible to implement a Boolean SAT solver that can be used for lazy SMT solving completely irrespective of the theory we use it with. The theory reasoning, on the other hand, does not need to bother with clauses and logical connectives, but purely focuses on sets of theory constraints.

While this has been the predominant approach for two decades and this \emph{separation of concerns} simplifies the implementation, it is by no means the only conceivable solution. \emph{Eager SMT solving} is still viable for certain logics and has been used a lot in the past, even~\cite{Davis1960} can be seen as an eager approach to solve first-order logic problems.

In~\cite{Jovanovic2012} and~\cite{Moura2013}, a new approach called \emph{\MCSAT} was presented that makes a certain part of the theory reasoning a \emph{first-class citizen} in the -- beforehand only Boolean -- core reasoning engine.
Similar to how a SAT solver builds a \emph{Boolean model} for the formula over time, the \emph{\MCSAT} solver also builds a \emph{theory model}. There is still a theory reasoning component that is decoupled from the core \MCSAT solver, but it \emph{only} needs to explain why a certain (partial) theory model is not feasible.

We first give a proper definition and introduction to the \MCSAT proof system.
Afterward, we discuss our main contributions concerning \MCSAT, consisting of some adaptations to the proof system, both improved and completely novel methods for theory reasoning, how to implement it within an existing SMT solver, and how to select proper heuristics.
The implementation is then experimentally evaluated.
Finally, we compare the \MCSAT proof system to other proof systems from a theoretic perspective, firstly using the notion of \emph{proof complexity} in comparison to the \emph{resolution proof system} and secondly using the notion of \emph{polynomial simulation} in comparison to the \CDCLT proof system.
